Mengautentikasi pengguna dengan Akun Google
Panduan memulai ini menunjukkan cara mengaktifkan Identity-Aware Proxy (IAP) untuk mengamankan aplikasi lingkungan standar atau fleksibel App Engine dan memberikan akses kepada pengguna dengan Akun Google.
Jika Anda berencana menayangkan resource dari jaringan penayangan konten (CDN), lihat panduan praktik terbaik caching untuk mengetahui informasi penting.
Jika aplikasi App Engine terdiri dari beberapa layanan, Anda dapat mengonfigurasi izin IAP yang berbeda di seluruh layanan, termasuk membuat hanya beberapa layanan dapat diakses secara publik, sementara layanan lainnya tetap terlindungi.
Untuk mengikuti panduan langkah demi langkah untuk tugas ini langsung di Google Cloud konsol, klik Pandu saya:
Sebelum memulai
- Login ke akun Google Cloud Anda. Jika Anda baru menggunakan Google Cloud, buat akun untuk mengevaluasi performa produk kami dalam skenario dunia nyata. Pelanggan baru juga mendapatkan kredit gratis senilai $300 untuk menjalankan, menguji, dan men-deploy workload.
-
In the Google Cloud console, on the project selector page, select or create a Google Cloud project.
Roles required to select or create a project
- Select a project: Selecting a project doesn't require a specific IAM role—you can select any project that you've been granted a role on.
-
Create a project: To create a project, you need the Project Creator role
(
roles/resourcemanager.projectCreator), which contains theresourcemanager.projects.createpermission. Learn how to grant roles.
-
If you're using an existing project for this guide, verify that you have the permissions required to complete this guide. If you created a new project, then you already have the required permissions.
-
Verify that billing is enabled for your Google Cloud project.
-
In the Google Cloud console, on the project selector page, select or create a Google Cloud project.
Roles required to select or create a project
- Select a project: Selecting a project doesn't require a specific IAM role—you can select any project that you've been granted a role on.
-
Create a project: To create a project, you need the Project Creator role
(
roles/resourcemanager.projectCreator), which contains theresourcemanager.projects.createpermission. Learn how to grant roles.
-
If you're using an existing project for this guide, verify that you have the permissions required to complete this guide. If you created a new project, then you already have the required permissions.
-
Verify that billing is enabled for your Google Cloud project.
-
Untuk mengaktifkan IAP untuk App Engine, Anda harus menyiapkan instance App Engine. Jika Anda belum menyiapkan instance App Engine, lihat Men-deploy ke App Engine untuk mengetahui langkah-langkah lengkapnya.
Secara default, IAP menggunakan klien OAuth yang dikelola Google, yang memerlukan project Anda menjadi bagian dari organisasi dan hanya mengizinkan akses ke pengguna internal.
Peran yang diperlukan
Untuk mendapatkan izin yang
diperlukan untuk mengautentikasi pengguna dengan Akun Google,
minta administrator Anda untuk memberi Anda
peran IAM Admin Kebijakan IAP (roles/iap.policyAdmin) di project Anda.
Untuk mengetahui informasi selengkapnya tentang cara memberikan peran, lihat Mengelola akses ke project, folder, dan organisasi.
Anda mungkin juga bisa mendapatkan izin yang diperlukan melalui peran khusus atau peran bawaan lainnya.
Mengaktifkan IAP
Konsol
Jika project Anda bukan milik organisasi, Anda harus menggunakan kredensial OAuth kustom.
If you haven't configured your project's OAuth consent screen, you'll be prompted to do so. To configure your OAuth consent screen, see Setting up your OAuth consent screen.
Setting up IAP access
-
Go to the
Identity-Aware Proxy page.
Go to the Identity-Aware Proxy page - Select the project you want to secure with IAP.
- Select the checkbox next to the resource you want to grant access to.
- On the right side panel, click Add principal.
-
In the Add principals dialog that appears, enter the email addresses of groups or
individuals who should have the IAP-secured Web App User role for the project.
The following kinds of principals can have this role:
- Google Account: user@gmail.com
- Google Group: admins@googlegroups.com
- Service account: server@example.gserviceaccount.com
- Google Workspace domain: example.com
Make sure to add a Google Account that you have access to.
- Select Cloud IAP > IAP-secured Web App User from the Roles drop-down list.
- Click Save.
Turning on IAP
-
On the Identity-Aware Proxy page, under Applications,
find the application you want to restrict
access to. To turn on IAP for a resource,
-
In the Turn on IAP window that appears, click Turn On to
confirm that you want IAP to secure your resource. After you turn on
IAP, it requires login credentials for all connections to your load balancer.
Only principals with the IAP-Secured Web App User (
roles/iap.httpsResourceAccessor) role on the project will be given access.
gcloud
Before you set up your project and IAP, you need an up-to-date version of the gcloud CLI. For instructions on how to install the gcloud CLI, see Install the gcloud CLI.
-
To authenticate, use the Google Cloud CLI and run the following command.
gcloud auth login - Click the URL that appears and sign in.
- After you sign in, copy the verification code that appears and paste it in the command line.
-
Run the following command to specify the project that contains the applications that you want to protect with IAP.
gcloud config set project PROJECT_ID -
To enable IAP, run the following command.
gcloud iap web enable --resource-type=app-engine --versions=version -
Add principals who should have the IAP-secured Web App user role to the project.
gcloud projects add-iam-policy-binding PROJECT_ID \ --member=PRINCIPAL_IDENTIFIER \ --role=roles/iap.httpsResourceAccessor- Replace PROJECT_ID with your project ID.
- Replace PRINCIPAL_IDENTIFIER with the necessary principals. This can be a
type of domain, group, serviceAccount, or user. For example,
user:myemail@example.com.
After you enable IAP, you can use the gcloud CLI to modify the
IAP access policy using the IAM role
roles/iap.httpsResourceAccessor. Learn more about
managing roles and permissions.
API
Run the following command to prepare a
settings.jsonfile.cat << EOF > settings.json { "iap": { "enabled":true } } EOFRun the following command to enable IAP.
curl -X PATCH \ -H "Authorization: Bearer $(gcloud auth print-access-token)" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -d @settings.json \ "https://appengine.googleapis.com/v1/apps/PROJECT_ID?updateMask=iap"
After you enable IAP, you can use the Google Cloud CLI to modify the
IAP access policy using the IAM role
roles/iap.httpsResourceAccessor. Learn more about
managing roles and permissions.
Anda dapat mengaktifkan IAP di layanan App Engine dalam
project Anda. Untuk membuat beberapa layanan dapat diakses secara publik dan memerlukan autentikasi untuk layanan lainnya, Anda dapat menggunakan tingkat akses yang berbeda di seluruh layanan.
Untuk mempelajari lebih lanjut, lihat Mengelola akses dengan IAP.
Untuk membuat layanan dapat diakses secara publik, berikan peran IAP-secured Web App User ke
allAuthenticatedUsers.
Menguji autentikasi pengguna
Setelah peran diberikan, akun utama dapat mengakses aplikasi dengan melakukan autentikasi dengan IAP. Akses URL aplikasi dari Akun Google yang diberi peran IAP-secured Web App User (
roles/iap.httpsResourceAccessor).Untuk menguji akses, buka jendela Samaran di Chrome, akses URL aplikasi, dan lakukan login saat diminta. Pengguna yang diberi peran IAP-secured Web App User (
roles/iap.httpsResourceAccessor) dan berhasil mengautentikasi dapat mengakses aplikasi. Pengguna yang tidak diberi peran yang diperlukan atau gagal mengautentikasi tidak dapat mengakses aplikasi.
Langkah berikutnya
- Pelajari cara mendapatkan identitas pengguna dan mengembangkan aplikasi App Engine Anda sendiri.